#ifndef __handle_h__
#define __handle_h__

template<class THANDLE=int,int INVALID_HANDLE=0> class Handled{
  protected:
    THANDLE Handle;

    Handled(){
      Handle=INVALID_HANDLE;
    };

    virtual void createHandle(){printf("error createhandle\n");};
    virtual void deleteHandle(){printf("error deletehandle\n");};
  public:
    int handleAllocated(){
      return Handle!=INVALID_HANDLE;
    };

    void handleNeeded(){
      if (!handleAllocated())
        createHandle();
    };

    THANDLE getHandle(){
      handleNeeded();
      return Handle;
    };

    void recreateHandle(){
      if (handleAllocated()){
        freeHandle();
        handleNeeded();
      }
    };

    void freeHandle(){
      if (Handle!=INVALID_HANDLE){
        deleteHandle();
        Handle=INVALID_HANDLE;
      }
    };
};

#endif

