/*
   Utilisation de la mini-bibliothque fournie pour grer les fentres.
   Il suffit de redfinir les membres virtuels de la classe Window, et
   la classe Application se chargera de mettre en oeuvre les appels
   ncessaires pour activer les diffrents vnements associs  une
   fentre (cration, raffichage, clavier, souris, etc...).

   Le programme se contente d'afficher un triangle color.
 */

#include "glut_import.h"
#include "application.h"

class DemoWindow:public Window{
  public:
    DemoWindow():Window("Fentre de dmonstration"){};

    void onCreate(){
      printf("Fenetre creee, appuyer sur [ESCAPE] pour quitter\n");
    };

    void onDisplay(){
      printf("Reaffichage\n");
      glClear(GL_COLOR_BUFFER_BIT);
      glBegin(GL_TRIANGLES);
        glColor3f(1,0,0);
        glVertex2f(-0.5,-0.7);
        glColor3f(0,1,0);
        glVertex2f(0.3,0.8);
        glColor3f(0,0,1);
        glVertex2f(0.7,-0.5);
      glEnd();

      glFlush();
      glutSwapBuffers();
    };
};

int main(){
  DemoWindow w;
  Application::run();
}

